> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://virtuous.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://virtuous.ferndocs.com/_mcp/server.

# Query donors based on specified criteria.

POST https://prod-api.raisedonors.com/api/Donor/query
Content-Type: application/json

When `includeDetails=true`, the response includes all related entities (DonorAddresses, DonorContactMethods)
similar to the GET by ID endpoint. This may impact performance for large result sets.

Reference: https://virtuous.ferndocs.com/reference/raise/donor/querydonors

## Authentication

- `Authorization` header (required) — JWT Authorization header using the Bearer scheme. Example: "Authorization: Bearer \{token}"

## Request

### Body (application/json)

This endpoint expects a Donor_querydonors_Request.

- `Donor_querydonors_Request`
  - QueryRequestModel: QueryRequestModel
  - ParsedQueryResponseModel: ParsedQueryResponseModel

## Response

### 200

OK

- `items` (list of DonorModel, optional)
- `total` (integer, optional)

## Errors

### 400 Bad Request Error

Bad Request

- `Donor_QueryDonorsRequestBadRequestError`
  - ProblemDetails: ProblemDetails
  - HttpValidationProblemDetails: HttpValidationProblemDetails

## Types

### QueryRequestModel

Request body for advanced query endpoints such as donor and campaign queries.

- `filter` (string, optional, nullable)
- `skip` (integer, optional)
- `take` (integer, optional)
- `sortBy` (enum, optional, nullable) — Field to sort by (case-insensitive). Valid options: createdate, createddatetime, email, firstname, gifts, giftsum, id, lastname, modifieddatetimeutc, name, phone
  - Allowed values: `createdate`, `createddatetime`, `email`, `firstname`, `gifts`, `giftsum`, `id`, `lastname`, `modifieddatetimeutc`, `name`, `phone`
- `descending` (boolean, optional)
- `includeDetails` (boolean, optional)
- `queryType` (enum, optional) — The logical type of query being executed.
  - Allowed values: `0`, `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`
- `groups` (list of QueryGroupModel, optional, nullable) — The groups of conditions that make up the query.
- `selectedColumns` (list of string, optional, nullable) — The list of result columns to return for each item.
- `empty` (boolean, optional) — Indicates whether the query has any conditions defined.

### ParsedQueryResponseModel

Represents a parsedquery response model.

- `descending` (boolean, optional)
- `empty` (boolean, optional) — Indicates whether the query has any conditions defined.
- `filter` (string, optional, nullable)
- `groups` (list of QueryGroupModel, optional, nullable) — The groups of conditions that make up the query.
- `includeDetails` (boolean, optional)
- `queryType` (enum, optional) — The logical type of query being executed.
  - Allowed values: `0`, `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`
- `selectedColumns` (list of string, optional, nullable) — The list of result columns to return for each item.
- `skip` (integer, optional)
- `sortBy` (enum, optional, nullable) — Field to sort by (case-insensitive). Valid options: createdate, createddatetime, email, firstname, gifts, giftsum, id, lastname, modifieddatetimeutc, name, phone
  - Allowed values: `createdate`, `createddatetime`, `email`, `firstname`, `gifts`, `giftsum`, `id`, `lastname`, `modifieddatetimeutc`, `name`, `phone`
- `take` (integer, optional)

### DonorModel

Represents a donor model.

- `id` (long, optional) — Gets or sets the identifier.
- `name` (string, optional, nullable) — Gets or sets the name.
- `title` (string, optional, nullable) — Gets or sets the title.
- `firstName` (string, optional, nullable) — Gets or sets the first name.
- `middleName` (string, optional, nullable) — Gets or sets the middle name.
- `lastName` (string, optional, nullable) — Gets or sets the last name.
- `suffix` (string, optional, nullable) — Gets or sets the suffix.
- `email` (string, optional, nullable) — Gets or sets the email address.
- `phone` (string, optional, nullable) — Gets or sets the phone.
- `createdDate` (string, optional, nullable) — Gets or sets the created date.
- `modifiedDate` (string, optional, nullable) — Gets or sets the modified date.
- `notes` (string, optional, nullable) — Gets or sets any additional notes.
- `isOrganization` (boolean, optional) — Gets or sets a value indicating whether organization.
- `organizationName` (string, optional, nullable) — Gets or sets the organization name.
- `crmKeyUrls` (map from string to CrmUrlInfo, optional, nullable) — Gets or sets the CRM URLs by integration type.
- `crmKey` (string, optional, nullable) — Gets or sets the crmkey.
- `crmSecondKey` (string, optional, nullable) — Gets or sets the crmsecond key.
- `isTestMode` (boolean, optional) — Gets or sets a value indicating whether test mode.
- `isArchived` (boolean, optional) — Gets or sets a value indicating whether archived.
- `isGDPRDeleted` (boolean, optional) — Gets or sets a value indicating whether gdprdeleted.
- `primaryAddress` (DonorAddressModel, optional, nullable) — Gets or sets the address.
- `donorAddresses` (list of DonorAddressModel, optional, nullable) — Gets or sets the donor addresses.
- `donorEmailAddresses` (list of DonorContactMethodModel, optional, nullable) — Gets or sets the donor email addresses.
- `donorPhoneNumbers` (list of DonorContactMethodModel, optional, nullable) — Gets or sets the donor phone numbers.

### ProblemDetails

- `type` (string, optional, nullable)
- `title` (string, optional, nullable)
- `status` (integer, optional, nullable)
- `detail` (string, optional, nullable)
- `instance` (string, optional, nullable)

### HttpValidationProblemDetails

- `detail` (string, optional, nullable)
- `errors` (map from string to list of string, optional, nullable)
- `instance` (string, optional, nullable)
- `status` (integer, optional, nullable)
- `title` (string, optional, nullable)
- `type` (string, optional, nullable)

### QueryGroupModel

- `conditions` (list of QueryConditionModel, optional, nullable) — Gets or sets the conditions.
- `conjunct` (enum, optional) — Gets or sets the operator.
  - Allowed values: `0`, `1`

### CrmUrlInfo

- `crmKey` (string, optional, nullable)
- `url` (string, optional, nullable)

### DonorAddressModel

Represents a donoraddress model.

- `address1` (string, optional, nullable) — Gets or sets the address1.
- `address2` (string, optional, nullable) — Gets or sets the address2.
- `addressType` (enum, optional) — Gets or sets the address type.
  - Allowed values: `0`, `1`, `2`, `3`, `4`, `5`
- `addressTypeDisplay` (string, optional, nullable) — Gets or sets the address type display.
- `city` (string, optional, nullable) — Gets or sets the city name.
- `countryString` (string, optional, nullable) — Gets or sets the country string.
- `donorId` (long, optional) — Gets or sets the donor identifier.
- `id` (long, optional) — Gets or sets the identifier.
- `isPrimary` (boolean, optional) — Gets or sets whether this is the primary address for the donor.
- `postal` (string, optional, nullable) — Gets or sets the postal or ZIP code.
- `state` (string, optional, nullable) — Gets or sets the state or province.

### DonorContactMethodModel

Represents a donorcontactmethod model.

- `id` (long, optional) — Gets or sets the identifier.
- `donorId` (long, optional) — Gets or sets the donor identifier.
- `type` (enum, optional) — Gets or sets the type.
  - Allowed values: `0`, `10`, `11`, `12`, `20`, `21`, `22`, `99`
- `typeDisplay` (string, optional, nullable) — Gets or sets the type display.
- `value` (string, optional, nullable) — Gets or sets the value.
- `secondaryValue` (string, optional, nullable) — Gets or sets the secondary value.
- `isPrimary` (boolean, optional) — Gets or sets a value indicating whether primary.
- `isOptedIn` (boolean, optional) — Gets or sets a value indicating whether opted in.
- `isValid` (boolean, optional) — Gets or sets the isval identifier.
- `isEmail` (boolean, optional) — Gets or sets the is email address.
- `isPhone` (boolean, optional) — Gets or sets a value indicating whether phone.
- `isBounced` (boolean, optional) — Gets or sets a value indicating whether bounced.
- `countryCode` (string, optional, nullable) — Gets or sets the country code.

### QueryConditionModel

- `parameter` (string, optional, nullable) — Gets or sets the parameter.
- `operator` (enum, optional) — Gets or sets the operator.
  - Allowed values: `0`, `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`, `10`, `11`, `12`, `13`, `14`, `15`, `16`, `17`, `18`, `19`, `20`, `21`, `22`, `23`, `24`, `25`, `26`, `27`, `28`, `29`
- `value` (string, optional, nullable) — Gets or sets the value.
- `secondaryValue` (string, optional, nullable) — Gets or sets the secondary value.
- `values` (list of string, optional, nullable) — Gets or sets the values.
- `conjunct` (enum, optional) — Gets or sets the operator.
  - Allowed values: `0`, `1`

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "items": [
    {
      "id": 1024,
      "name": "John A. Smith",
      "title": "Mr.",
      "firstName": "John",
      "middleName": "Allen",
      "lastName": "Smith",
      "suffix": "Jr.",
      "email": "john.smith@example.org",
      "phone": "+1-555-123-4567",
      "createdDate": "2023-11-15T09:30:00Z",
      "modifiedDate": "2024-05-20T14:45:00Z",
      "notes": "Preferred contact time: afternoons. Interested in monthly newsletters.",
      "isOrganization": false,
      "organizationName": "",
      "crmKeyUrls": {},
      "crmKey": "CRM123456789",
      "crmSecondKey": "ALT987654321",
      "isTestMode": false,
      "isArchived": false,
      "isGDPRDeleted": false,
      "primaryAddress": {
        "address1": "123 Maple Street",
        "address2": "Apt 4B",
        "addressType": 1,
        "addressTypeDisplay": "Home",
        "city": "Springfield",
        "countryString": "USA",
        "donorId": 1024,
        "id": 501,
        "isPrimary": true,
        "postal": "62704",
        "state": "IL"
      },
      "donorAddresses": [
        {
          "address1": "123 Maple Street",
          "address2": "Apt 4B",
          "addressType": 1,
          "addressTypeDisplay": "Home",
          "city": "Springfield",
          "countryString": "USA",
          "donorId": 1024,
          "id": 501,
          "isPrimary": true,
          "postal": "62704",
          "state": "IL"
        },
        {
          "address1": "456 Oak Avenue",
          "address2": "",
          "addressType": 2,
          "addressTypeDisplay": "Work",
          "city": "Chicago",
          "countryString": "USA",
          "donorId": 1024,
          "id": 502,
          "isPrimary": false,
          "postal": "60616",
          "state": "IL"
        }
      ],
      "donorEmailAddresses": [
        {
          "id": 301,
          "donorId": 1024,
          "type": 10,
          "typeDisplay": "Personal Email",
          "value": "john.smith@example.org",
          "secondaryValue": "",
          "isPrimary": true,
          "isOptedIn": true,
          "isValid": true,
          "isEmail": true,
          "isPhone": false,
          "isBounced": false,
          "countryCode": "US"
        },
        {
          "id": 302,
          "donorId": 1024,
          "type": 11,
          "typeDisplay": "Work Email",
          "value": "j.smith@company.com",
          "secondaryValue": "",
          "isPrimary": false,
          "isOptedIn": false,
          "isValid": true,
          "isEmail": true,
          "isPhone": false,
          "isBounced": false,
          "countryCode": "US"
        }
      ],
      "donorPhoneNumbers": [
        {
          "id": 401,
          "donorId": 1024,
          "type": 20,
          "typeDisplay": "Mobile",
          "value": "+1-555-123-4567",
          "secondaryValue": "",
          "isPrimary": true,
          "isOptedIn": true,
          "isValid": true,
          "isEmail": false,
          "isPhone": true,
          "isBounced": false,
          "countryCode": "US"
        },
        {
          "id": 402,
          "donorId": 1024,
          "type": 21,
          "typeDisplay": "Home Phone",
          "value": "+1-555-765-4321",
          "secondaryValue": "",
          "isPrimary": false,
          "isOptedIn": false,
          "isValid": true,
          "isEmail": false,
          "isPhone": true,
          "isBounced": false,
          "countryCode": "US"
        }
      ]
    }
  ],
  "total": 1
}
```

**SDK Code**

```python
import requests

url = "https://prod-api.raisedonors.com/api/Donor/query"

payload = {}
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://prod-api.raisedonors.com/api/Donor/query';
const options = {
  method: 'POST',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://prod-api.raisedonors.com/api/Donor/query"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://prod-api.raisedonors.com/api/Donor/query")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://prod-api.raisedonors.com/api/Donor/query")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://prod-api.raisedonors.com/api/Donor/query', [
  'body' => '{}',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://prod-api.raisedonors.com/api/Donor/query");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://prod-api.raisedonors.com/api/Donor/query")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```